fix Device: Cleanup previous interfaces
[csit.git] / resources / libraries / bash / function / device.sh
index 7a61bf7..228a73b 100644 (file)
@@ -1,4 +1,4 @@
-# Copyright (c) 2019 Cisco and/or its affiliates.
+# Copyright (c) 2021 Cisco and/or its affiliates.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
 set -exuo pipefail
 
 # This library defines functions used by multiple entry scripts.
+# Deliberately not depending on common.sh to allow standalone usage.
 # Keep functions ordered alphabetically, please.
 
 function activate_wrapper () {
+
     # Acts as wrapper for activate docker topology.
     #
     # Variables read:
@@ -37,6 +39,7 @@ function activate_wrapper () {
 
 
 function bind_interfaces_to_containers () {
+
     # Bind linux network interface to container and create symlink for PCI
     # address in container.
     #
@@ -75,7 +78,7 @@ function bind_interfaces_to_containers () {
         sudo ip link set ${NETDEV} netns ${DCR_CPIDS[dut1]} || {
             die "Moving interface to ${DCR_CPIDS[dut1]} namespace failed!"
         }
-        docker exec "${DCR_UUIDS[dut1]}" ${cmd} ||  {
+        docker exec "${DCR_UUIDS[dut1]}" ${cmd} || {
             die "Linking PCI address in container failed!"
         }
     done
@@ -83,6 +86,7 @@ function bind_interfaces_to_containers () {
 
 
 function bind_interfaces_to_driver () {
+
     # Bind network interface specified by parameter to driver specified by
     # parameter.
     #
@@ -90,17 +94,15 @@ function bind_interfaces_to_driver () {
     # - ADDR - PCI address of network interface.
     # - DRIVER - Kernel driver.
 
+    set -exuo pipefail
+
     pci_path="/sys/bus/pci/devices/${ADDR}"
     drv_path="/sys/bus/pci/drivers/${DRIVER}"
-    vd="$(cat ${pci_path}/vendor ${pci_path}/device)" || {
-        die "Failed to retrieve interface details!"
-    }
-    set +e
-    echo ${vd} | sudo tee ${drv_path}/new_id
-    set -e
-    echo ${ADDR} | sudo tee ${pci_path}/driver/unbind || {
-        die "Failed to unbind interface ${ADDR}!"
-    }
+    if [ -d "${pci_path}/driver" ]; then
+        echo ${ADDR} | sudo tee ${pci_path}/driver/unbind || {
+            die "Failed to unbind interface ${ADDR}!"
+        }
+    fi
     echo ${ADDR} | sudo tee ${drv_path}/bind || {
         die "Failed to bind interface ${ADDR}!"
     }
@@ -108,6 +110,7 @@ function bind_interfaces_to_driver () {
 
 
 function clean_environment () {
+
     # Cleanup environment by removing topology containers and shared volumes
     # and binding interfaces back to original driver.
     #
@@ -124,9 +127,10 @@ function clean_environment () {
     # Kill docker containers.
     docker rm --force "${DCR_UUIDS[@]}" || die "Cleanup containers failed!"
 
-    # Remove DUT1 /tmp volume
-    docker volume rm "${DCR_VOLUMES[dut1]}" || {
-        die "Failed to remove DUT1 /tmp volume!"
+    # Check if there are some leftover containers and remove all. Command will
+    # not fail in case there are no containers to remove.
+    docker rm --force $(docker ps -q --filter name=${DCR_UUIDS[dut1]}) || {
+        warn "Failed to remove hanged containers or nothing to remove!"
     }
 
     # Rebind interfaces back to kernel drivers.
@@ -142,10 +146,13 @@ function clean_environment () {
 
 
 function clean_environment_on_exit () {
+
     # Cleanup environment by removing topology containers and binding
     # interfaces back to original driver only if exit code is not 0.
     # This function acts as workaround as 'set -eu' does not trigger ERR trap.
 
+    set -exuo pipefail
+
     if [ $? -ne 0 ]; then
         clean_environment || die
     fi
@@ -153,6 +160,7 @@ function clean_environment_on_exit () {
 
 
 function deactivate_wrapper () {
+
     # Acts as wrapper for deactivate docker topology.
     #
     # Variables read:
@@ -168,9 +176,12 @@ function deactivate_wrapper () {
 
 
 function die () {
+
     # Print the message to standard error end exit with error code specified
     # by the second argument.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Hardcoded values:
     # - The default error message.
     # Arguments:
@@ -185,6 +196,7 @@ function die () {
 
 
 function enter_mutex () {
+
     # Enter mutual exclusion for protecting execution from starvation and
     # deadlock.
 
@@ -207,6 +219,7 @@ function enter_mutex () {
 
 
 function exit_mutex () {
+
     # Exit mutual exclusion.
 
     set -exuo pipefail
@@ -221,117 +234,152 @@ function exit_mutex () {
 
 
 function get_available_interfaces () {
+
     # Find and get available Virtual functions.
     #
     # Arguments:
-    # - ${1} - Node flavor string, usually describing the processor and node
-    # multiplicity of desired testbed, separated by underscore.
+    # - ${1} - Nodeness, as set by common.sh get_test_code.
+    # - ${2} - Flavor, as set by common.sh get_test_code.
     # Variables set:
     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
     # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
+    # - DUT1_VLANS - List of interface vlans to TG container.
+    # - DUT1_MODEL - List of interface models to TG container.
     # - TG_NETDEVS - List of network devices allocated to TG container.
     # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
     # - TG_NETMACS - List of MAC addresses allocated to TG container.
     # - TG_DRIVERS - List of interface drivers to TG container.
+    # - TG_VLANS - List of interface vlans to TG container.
+    # - TG_MODEL - List of interface models to TG container.
 
     set -exuo pipefail
 
-    # Following code is specifing VFs ID based on nodeness and flavor.
+    # Following code is specifying VFs ID based on nodeness and flavor.
     # As there is great variability in hardware configuration outside LF,
-    # from bootstrap architecure point of view these are considered as flavors.
+    # from bootstrap architecture point of view these are considered as flavors.
     # Anyone can override flavor for its own machine and add condition here.
     # See http://pci-ids.ucw.cz/v2.2/pci.ids for more info.
     case_text="${1}_${2}"
     case "${case_text}" in
         "1n_skx")
+            # Add Intel Corporation XL710/X710 Virtual Function to the
+            # whitelist.
+            # Add Intel Corporation E810 Virtual Function to the
+            # whitelist.
+            pci_id="0x154c\|0x1889"
+            tg_netdev=(ens1 enp134)
+            dut1_netdev=(ens5 enp175)
+            ports_per_nic=2
+            ;;
+       "1n_tx2")
             # Add Intel Corporation XL710/X710 Virtual Function to the
             # whitelist.
             pci_id="0x154c"
-            tg_netdev=(enp24)
-            dut1_netdev=(enp59)
+            tg_netdev=(enp5)
+            dut1_netdev=(enp145)
+            ports_per_nic=2
             ;;
-        "1n_vbox")
+       "1n_vbox")
             # Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
             # whitelist.
             pci_id="0x100f"
-            tg_netdev=(eth1 eth2)
-            dut1_netdev=(eth3 eth4)
+            tg_netdev=(enp0s8 enp0s9)
+            dut1_netdev=(enp0s16 enp0s17)
+            ports_per_nic=1
             ;;
         *)
             die "Unknown specification: ${case_text}!"
     esac
 
-    net_path="/sys/bus/pci/devices/*/net/*"
-
     # TG side of connections.
     TG_NETDEVS=()
     TG_PCIDEVS=()
     TG_NETMACS=()
     TG_DRIVERS=()
+    TG_VLANS=()
+    TG_MODEL=()
     # DUT1 side of connections.
     DUT1_NETDEVS=()
     DUT1_PCIDEVS=()
     DUT1_NETMACS=()
     DUT1_DRIVERS=()
+    DUT1_VLANS=()
+    DUT1_MODEL=()
 
-    # Following code is filtering available VFs represented by network device
-    # name. Only allowed VFs PCI IDs are used.
-    for netdev in \
-        $(find ${net_path} -type d -name . -o -prune -exec basename '{}' ';');
+    # Find the first ${device_count} number of available TG Linux network
+    # VF device names. Only allowed VF PCI IDs are filtered.
+    for netdev in ${tg_netdev[@]}
     do
-        if grep -q "${pci_id}" "/sys/class/net/${netdev}/device/device"; then
-            # We will filter to TG/DUT1 side of connection (this can be in
-            # future overriden by more advanced conditions for mapping).
-            for sub in ${tg_netdev[@]}; do
-                if [[ "${netdev#*$sub}" != "${netdev}" ]]; then
-                    tg_side+=(${netdev})
-                fi
-            done
-            for sub in ${dut1_netdev[@]}; do
-                if [[ "${netdev#*$sub}" != "${netdev}" ]]; then
-                    dut1_side+=(${netdev})
-                fi
-            done
+        ports=0
+        for netdev_path in $(grep -l "${pci_id}" \
+                             /sys/class/net/${netdev}*/device/device \
+                             2> /dev/null)
+        do
+            if [[ ${ports} -lt ${ports_per_nic} ]]; then
+                tg_netdev_name=$(dirname ${netdev_path})
+                tg_netdev_name=$(dirname ${tg_netdev_name})
+                TG_NETDEVS+=($(basename ${tg_netdev_name}))
+                ((ports++))
+            else
+                break
+            fi
+        done
+        ports_per_device=$((${ports_per_nic}*${#tg_netdev[@]}))
+        if [[ ${#TG_NETDEVS[@]} -eq ${ports_per_device} ]]; then
+            break
         fi
     done
 
-    for netdev in "${tg_side[@]::2}"; do
-        TG_NETDEVS+=(${netdev})
-    done
-    for netdev in "${dut1_side[@]::2}"; do
-        DUT1_NETDEVS+=(${netdev})
+    i=0
+    for netdev in "${TG_NETDEVS[@]}"; do
+        # Find the index of selected tg netdev among tg_netdevs
+        # e.g. enp8s5f7 is a vf of netdev enp8s5 with index 11
+        # and the corresponding dut1 netdev is enp133s13.
+        while [[ "${netdev}" != "${tg_netdev[$i]}"* ]]; do
+            ((i++))
+        done
+        # Rename tg netdev to dut1 netdev
+        # e.g. enp8s5f7 -> enp133s13f7
+        DUT1_NETDEVS+=(${netdev/${tg_netdev[$i]}/${dut1_netdev[$i]}})
+        # Don't need to reset i, all netdevs are sorted.
     done
 
     for NETDEV in "${TG_NETDEVS[@]}"; do
         get_pci_addr
         get_mac_addr
         get_krn_driver
+        get_vlan_filter
+        get_csit_model
         TG_PCIDEVS+=(${PCI_ADDR})
         TG_NETMACS+=(${MAC_ADDR})
         TG_DRIVERS+=(${KRN_DRIVER})
+        TG_VLANS+=(${VLAN_ID})
+        TG_MODELS+=(${MODEL})
     done
     for NETDEV in "${DUT1_NETDEVS[@]}"; do
         get_pci_addr
         get_mac_addr
         get_krn_driver
+        get_vlan_filter
+        get_csit_model
         DUT1_PCIDEVS+=(${PCI_ADDR})
         DUT1_NETMACS+=(${MAC_ADDR})
         DUT1_DRIVERS+=(${KRN_DRIVER})
+        DUT1_VLANS+=(${VLAN_ID})
+        DUT1_MODELS+=(${MODEL})
     done
 
     # We need at least two interfaces for TG/DUT1 for building topology.
-    if [ "${#TG_NETDEVS[@]}" -ne 2 ] || [ "${#DUT1_NETDEVS[@]}" -ne 2 ]; then
+    if [ "${#TG_NETDEVS[@]}" -lt 2 ] || [ "${#DUT1_NETDEVS[@]}" -lt 2 ]; then
         die "Not enough linux network interfaces found!"
     fi
-    if [ "${#TG_PCIDEVS[@]}" -ne 2 ] || [ "${#DUT1_PCIDEVS[@]}" -ne 2 ]; then
-        die "Not enough pci interfaces found!"
-    fi
 }
 
 
 function get_krn_driver () {
+
     # Get kernel driver from linux network device name.
     #
     # Variables read:
@@ -349,6 +397,7 @@ function get_krn_driver () {
 
 
 function get_mac_addr () {
+
     # Get MAC address from linux network device name.
     #
     # Variables read:
@@ -366,7 +415,37 @@ function get_mac_addr () {
 }
 
 
+function get_csit_model () {
+
+    # Get CSIT model name from linux network device name.
+    #
+    # Variables read:
+    # - NETDEV - Linux network device name.
+    # Variables set:
+    # - MODEL - CSIT model name of network device.
+
+    set -exuo pipefail
+
+    if [ -d /sys/class/net/${NETDEV}/device ]; then
+        ID="$(</sys/class/net/${NETDEV}/device/device)" || {
+            die "Failed to get device id of linux network interface!"
+        }
+        case "${ID}" in
+            "0x1592"|"0x1889")
+                MODEL="Intel-E810CQ"
+                ;;
+            "0x1572"|"0x154c")
+                MODEL="Intel-X710"
+                ;;
+            "*")
+                MODEL="virtual"
+        esac
+    fi
+}
+
+
 function get_pci_addr () {
+
     # Get PCI address in <domain>:<bus:<device>.<func> format from linux network
     # device name.
     #
@@ -388,36 +467,109 @@ function get_pci_addr () {
 }
 
 
-function installed () {
+function get_vlan_filter () {
+
+    # Get VLAN stripping filter from PF searched by mac adress.
+    #
+    # Variables read:
+    # - MAC_ADDR - MAC address of VF.
+    # Variables set:
+    # - VLAN_ID - VLAN ids.
 
     set -exuo pipefail
 
+    # Sed regular expression pattern.
+    exp="s/^.*vlan ([[:digit:]]+).*$/\1/"
+    VLAN_ID=$(ip link | grep vlan | grep ${MAC_ADDR} | sed -re "${exp}") || true
+    VLAN_ID="${VLAN_ID:-0}"
+}
+
+
+function installed () {
+
     # Check if the given utility is installed. Fail if not installed.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Arguments:
     # - ${1} - Utility to check.
     # Returns:
     # - 0 - If command is installed.
     # - 1 - If command is not installed.
 
+    set -exuo pipefail
+
     command -v "${1}"
 }
 
 
+function parse_env_variables () {
+
+    # Parse environment variables.
+    #
+    # Variables read, set or exported: Multiple,
+    # see the code for the current list.
+
+    set -exuo pipefail
+
+    IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+    IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+    IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+    IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+    IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+    IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+    IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+    IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+    IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+    IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
+
+    for port in $(seq "${#TG_NETMACS[*]}"); do
+        CSIT_TG_INTERFACES+=$(cat << EOF
+        port$((port-1)):
+            mac_address: "${TG_NETMACS[$((port-1))]}"
+            pci_address: "${TG_PCIDEVS[$((port-1))]}"
+            link: "link$((port-1))"
+            model: ${TG_MODELS[$((port-1))]}
+            driver: "${TG_DRIVERS[$((port-1))]}"
+            vlan: ${TG_VLANS[$((port-1))]}
+EOF
+    )
+        CSIT_TG_INTERFACES+=$'\n'
+    done
+    for port in $(seq "${#DUT1_NETMACS[*]}"); do
+        CSIT_DUT1_INTERFACES+=$(cat << EOF
+        port$((port-1)):
+            mac_address: "${DUT1_NETMACS[$((port-1))]}"
+            pci_address: "${DUT1_PCIDEVS[$((port-1))]}"
+            link: "link$((port-1))"
+            model: ${DUT1_MODELS[$((port-1))]}
+            driver: "${DUT1_DRIVERS[$((port-1))]}"
+            vlan: ${DUT1_VLANS[$((port-1))]}
+EOF
+    )
+        CSIT_DUT1_INTERFACES+=$'\n'
+    done
+}
+
+
 function print_env_variables () {
+
     # Get environment variables prefixed by CSIT_.
 
     set -exuo pipefail
 
-    env | grep CSIT_
+    env | grep CSIT_ || true
 }
 
 
 function read_env_variables () {
+
     # Read environment variables from parameters.
     #
     # Arguments:
     # - ${@} - Variables passed as an argument.
+    # Variables read, set or exported: Multiple,
+    # see the code for the current list.
 
     set -exuo pipefail
 
@@ -425,33 +577,41 @@ function read_env_variables () {
         export "${param}"
     done
     declare -gA DCR_UUIDS
-    declare -gA DCR_VOLUMES
     DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
     DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
-    DCR_VOLUMES+=([dut1]="${CSIT_DUT1_VOL}")
-    TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
-    TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
-    TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
-    TG_DRIVERS+=("${CSIT_TG_INTERFACES_PORT2_DRV}")
-    DUT1_PCIDEVS=("${CSIT_DUT1_INTERFACES_PORT1_PCI}")
-    DUT1_DRIVERS=("${CSIT_DUT1_INTERFACES_PORT1_DRV}")
-    DUT1_PCIDEVS+=("${CSIT_DUT1_INTERFACES_PORT2_PCI}")
-    DUT1_DRIVERS+=("${CSIT_DUT1_INTERFACES_PORT2_DRV}")
+
+    IFS=@ read -a TG_NETMACS <<< "${CSIT_TG_INTERFACES_PORT_MAC}"
+    IFS=@ read -a TG_PCIDEVS <<< "${CSIT_TG_INTERFACES_PORT_PCI}"
+    IFS=@ read -a TG_DRIVERS <<< "${CSIT_TG_INTERFACES_PORT_DRV}"
+    IFS=@ read -a TG_VLANS <<< "${CSIT_TG_INTERFACES_PORT_VLAN}"
+    IFS=@ read -a TG_MODELS <<< "${CSIT_TG_INTERFACES_PORT_MODEL}"
+    IFS=@ read -a DUT1_NETMACS <<< "${CSIT_DUT1_INTERFACES_PORT_MAC}"
+    IFS=@ read -a DUT1_PCIDEVS <<< "${CSIT_DUT1_INTERFACES_PORT_PCI}"
+    IFS=@ read -a DUT1_DRIVERS <<< "${CSIT_DUT1_INTERFACES_PORT_DRV}"
+    IFS=@ read -a DUT1_VLANS <<< "${CSIT_DUT1_INTERFACES_PORT_VLAN}"
+    IFS=@ read -a DUT1_MODELS <<< "${CSIT_DUT1_INTERFACES_PORT_MODEL}"
 }
 
 
 function set_env_variables () {
+
     # Set environment variables.
     #
     # Variables read:
     # - DCR_UUIDS - Docker Container UUIDs.
     # - DCR_PORTS - Docker Container's SSH ports.
-    # - DUT1_NETMACS - List of network devices MAC addresses of DUT1 container.
-    # - DUT1_PCIDEVS - List of PCI addresses of devices of DUT1 container.
+    # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
+    # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
+    # - DUT1_NETMACS - List of MAC addresses allocated to DUT1 container.
     # - DUT1_DRIVERS - List of interface drivers to DUT1 container.
-    # - TG_NETMACS - List of network devices MAC addresses of TG container.
-    # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
+    # - DUT1_VLANS - List of interface vlans to TG container.
+    # - DUT1_MODEL - List of interface models to TG container.
+    # - TG_NETDEVS - List of network devices allocated to TG container.
+    # - TG_PCIDEVS - List of PCI addresses allocated to TG container.
+    # - TG_NETMACS - List of MAC addresses allocated to TG container.
     # - TG_DRIVERS - List of interface drivers to TG container.
+    # - TG_VLANS - List of interface vlans to TG container.
+    # - TG_MODEL - List of interface models to TG container.
 
     set -exuo pipefail
 
@@ -472,24 +632,25 @@ function set_env_variables () {
     CSIT_DUT1_ARCH="$(uname -i)" || {
         die "Reading machine architecture failed!"
     }
-    CSIT_DUT1_VOL="${DCR_VOLUMES[dut1]}"
-    CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
-    CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
-    CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
-    CSIT_TG_INTERFACES_PORT2_MAC="${TG_NETMACS[1]}"
-    CSIT_TG_INTERFACES_PORT2_PCI="${TG_PCIDEVS[1]}"
-    CSIT_TG_INTERFACES_PORT2_DRV="${TG_DRIVERS[1]}"
-    CSIT_DUT1_INTERFACES_PORT1_MAC="${DUT1_NETMACS[0]}"
-    CSIT_DUT1_INTERFACES_PORT1_PCI="${DUT1_PCIDEVS[0]}"
-    CSIT_DUT1_INTERFACES_PORT1_DRV="${DUT1_DRIVERS[0]}"
-    CSIT_DUT1_INTERFACES_PORT2_MAC="${DUT1_NETMACS[1]}"
-    CSIT_DUT1_INTERFACES_PORT2_PCI="${DUT1_PCIDEVS[1]}"
-    CSIT_DUT1_INTERFACES_PORT2_DRV="${DUT1_DRIVERS[1]}"
+    OIFS="$IFS" IFS=@
+    set -a
+    CSIT_TG_INTERFACES_PORT_MAC="${TG_NETMACS[*]}"
+    CSIT_TG_INTERFACES_PORT_PCI="${TG_PCIDEVS[*]}"
+    CSIT_TG_INTERFACES_PORT_DRV="${TG_DRIVERS[*]}"
+    CSIT_TG_INTERFACES_PORT_VLAN="${TG_VLANS[*]}"
+    CSIT_TG_INTERFACES_PORT_MODEL="${TG_MODELS[*]}"
+    CSIT_DUT1_INTERFACES_PORT_MAC="${DUT1_NETMACS[*]}"
+    CSIT_DUT1_INTERFACES_PORT_PCI="${DUT1_PCIDEVS[*]}"
+    CSIT_DUT1_INTERFACES_PORT_DRV="${DUT1_DRIVERS[*]}"
+    CSIT_DUT1_INTERFACES_PORT_VLAN="${DUT1_VLANS[*]}"
+    CSIT_DUT1_INTERFACES_PORT_MODEL="${DUT1_MODELS[*]}"
     set +a
+    IFS="$OIFS"
 }
 
 
 function start_topology_containers () {
+
     # Starts csit-sut-dcr docker containers for TG/DUT1.
     #
     # Variables read:
@@ -518,17 +679,24 @@ function start_topology_containers () {
     # Automatically remove the container when it exits.
     dcr_stc_params+="--rm "
     # Size of /dev/shm.
-    dcr_stc_params+="--shm-size 512M "
+    dcr_stc_params+="--shm-size 2G "
     # Override access to PCI bus by attaching a filesystem mount to the
     # container.
     dcr_stc_params+="--mount type=tmpfs,destination=/sys/bus/pci/devices "
-    # Mount vfio to be able to bind to see binded interfaces. We cannot use
-    # --device=/dev/vfio as this does not see newly binded interfaces.
+    # Mount vfio to be able to bind to see bound interfaces. We cannot use
+    # --device=/dev/vfio as this does not see newly bound interfaces.
     dcr_stc_params+="--volume /dev/vfio:/dev/vfio "
-    # Mount nested_vm image to be able to run VM tests.
-    dcr_stc_params+="--volume /var/lib/vm/vhost-nested.img:/var/lib/vm/vhost-nested.img "
+    # Disable manipulation with hugepages by VPP.
+    dcr_stc_params+="--volume /dev/null:/etc/sysctl.d/80-vpp.conf "
     # Mount docker.sock to be able to use docker deamon of the host.
     dcr_stc_params+="--volume /var/run/docker.sock:/var/run/docker.sock "
+    # Mount /opt/boot/ where VM kernel and initrd are located.
+    dcr_stc_params+="--volume /opt/boot/:/opt/boot/ "
+    # Mount host hugepages for VMs.
+    dcr_stc_params+="--volume /dev/hugepages/:/dev/hugepages/ "
+    # Disable IPv6.
+    dcr_stc_params+="--sysctl net.ipv6.conf.all.disable_ipv6=1 "
+    dcr_stc_params+="--sysctl net.ipv6.conf.default.disable_ipv6=1 "
 
     # Docker Container UUIDs.
     declare -gA DCR_UUIDS
@@ -536,26 +704,14 @@ function start_topology_containers () {
     declare -gA DCR_PORTS
     # Docker Container PIDs (namespaces).
     declare -gA DCR_CPIDS
-    # Docker Container volumes with no relationship to the host.
-    declare -gA DCR_VOLUMES
-
-    # Create DUT1 /tmp volume to be able to install VPP in "nested" container.
-    params=(--name DUT1_VOL_$(uuidgen))
-    DCR_VOLUMES+=([dut1]="$(docker volume create "${params[@]}")") || {
-        die "Failed to create DUT1 /tmp volume!"
-    }
-
-    # Mount DUT1_VOL as /tmp directory on DUT1 container
-    dcr_stc_params_dut1="--volume ${DCR_VOLUMES[dut1]}:/tmp "
 
     # Run TG and DUT1. As initial version we do support only 2-node.
     params=(${dcr_stc_params} --name csit-tg-$(uuidgen) ${dcr_image})
-    DCR_UUIDS+=([tg]="$(docker run "${params[@]}")") || {
+    DCR_UUIDS+=([tg]=$(docker run "${params[@]}")) || {
         die "Failed to start TG docker container!"
     }
-    params=(${dcr_stc_params} ${dcr_stc_params_dut1}
-            --name csit-dut1-$(uuidgen) ${dcr_image})
-    DCR_UUIDS+=([dut1]="$(docker run "${params[@]}")") || {
+    params=(${dcr_stc_params} --name csit-dut1-$(uuidgen) ${dcr_image})
+    DCR_UUIDS+=([dut1]=$(docker run "${params[@]}")) || {
         die "Failed to start DUT1 docker container!"
     }
 
@@ -565,21 +721,21 @@ function start_topology_containers () {
 
     # Get Containers TCP ports.
     params=(${DCR_UUIDS[tg]})
-    DCR_PORTS+=([tg]="$(docker port "${params[@]}")") || {
+    DCR_PORTS+=([tg]=$(docker port "${params[@]}")) || {
         die "Failed to get port of TG docker container!"
     }
     params=(${DCR_UUIDS[dut1]})
-    DCR_PORTS+=([dut1]="$(docker port "${params[@]}")") || {
+    DCR_PORTS+=([dut1]=$(docker port "${params[@]}")) || {
         die "Failed to get port of DUT1 docker container!"
     }
 
     # Get Containers PIDs.
     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[tg]})
-    DCR_CPIDS+=([tg]="$(docker inspect "${params[@]}")") || {
+    DCR_CPIDS+=([tg]=$(docker inspect "${params[@]}")) || {
         die "Failed to get PID of TG docker container!"
     }
     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[dut1]})
-    DCR_CPIDS+=([dut1]="$(docker inspect "${params[@]}")") || {
+    DCR_CPIDS+=([dut1]=$(docker inspect "${params[@]}")) || {
         die "Failed to get PID of DUT1 docker container!"
     }
 }
@@ -587,8 +743,12 @@ function start_topology_containers () {
 function warn () {
     # Print the message to standard error.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Arguments:
     # - ${@} - The text of the message.
 
+    set -exuo pipefail
+
     echo "$@" >&2
 }